/* Atliko: Vaida eikut
   Grup: 6
   Uduotis (nr.30): Realizuoti Rabin-Karp algoritma.
*/

#include <stdio.h>
#include <string.h>

#define q 65521
#define d 257

int RabinKarp(char *pattern, char *text);

int main() {

  char txt[255], pat[255];
  int bufcount, pat_len, match_number;

  printf("Enter the text: \n");
  scanf("%s", txt);

  printf("Enter the pattern: \n");
  scanf("%s", pat);

  bufcount = strlen(txt);
  pat_len = strlen(pat);

  match_number = RabinKarp(pat, txt);

  printf("\n Text Length             = %d", bufcount);
  printf("\n Search Pattern          = %s", pat);
  printf("\n Pattern Length          = %d", pat_len);
  printf("\n Total Number of Matches = %d\n", match_number);
  return 0;

}
 
int RabinKarp(char *pattern, char *text) {

  char *b;
  int i;
  int match_number = 0;
  int txt_length, pat_length;
  long d_pat;
  long h_txt, h_pat, oldhash;

  txt_length = strlen(text);
  pat_length = strlen(pattern);
  /* computes d_pat = 2^(pattern_length-1) */
  d_pat = 1;
  for(i = 1; i < pat_length; i++)
    d_pat = (d_pat * d) % q;

  h_pat = pattern[0];
  h_txt = text[0];

  // initialize hash values for pattern and text

  for (i = 1; i < pat_length; i++) {
    h_pat = (d * h_pat + pattern[i]) % q;
    h_txt = (d * h_txt + text[i]) % q;
  }

   // Now search the pattern in text

  for(i = 0, b = text; b <= text + txt_length - pat_length; b++, i++ ) {
    if (h_txt == h_pat && !strncmp(pattern, b, pat_length) && ++match_number) {
    //compares pattern and text hash values, if equal then a try_number
    //is increamented and try to find sure exact character match.
      printf("Pattern '%s' is found at character position from %d to %d\n", pattern, i+1, i + pat_length);   // pat, i - pat_len, i - 1
    }
    // remove old hash value of text and calculate for next set.
    oldhash = (d_pat * b[0]) % q;      //removing previous txt_hash value
    oldhash = ((h_txt + q) - oldhash) % q;
    h_txt = (d * oldhash + b[pat_length]) % q;   //and calculate new one with next character
  }
  return match_number;
  
}

